/*
 * State.java
 *
 * Created on 9. jen 2006, 17:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package uloha1;

/**
 * @author zelial
 */
public class State {
    /**reprezentace leveho brehu a stavu lodi (pravy breh si dopocitame za behu)
     *trojice znamena pocet: misionaru, kanibalu, lodek na levem brehu **/
    private int breh[] = {3,3,1};
    //predchudce stavu (vznikl aplikaci jednoho z operatoru)
    //slouzi pro rekonstrukci cesty
    public State predek = null;
    
    /** Creates a new instance of State **/
    public State(int a, int b, int c)
    throws Exception{
        if (c != 0 & c != 1){
            throw new Exception("spatna hodnota stavu lodi");
        }
        breh[0] = a;
        breh[1] = b;
        breh[2] = c;
    }
    /** konstruktor realizujici zmenu stavu - vytvori novy stav
     *ze stareho stavu pomoci jedne z 5 operaci
     *hodi vyjimku, pokud by vznkly stav byl nepripustny.
     implementace je lehce krkolomna, aby sel jednoduse rozlisit kod
     jednotlivych operatoru**/
    public State(State s,int operator)
    throws Exception{
        if (operator == 1){//vezu jednoho misionare
            if ((s.isLeft() && s.breh[0] == 0) || (!s.isLeft() && s.breh[0] == 3)){
                throw new Exception("operator 1 nelze pouzit");
            }
            if (s.isLeft()){
                breh[0] = s.breh[0]-1;
            }else{
                breh[0] = s.breh[0]+1;
            }
            breh[1] = s.breh[1];
        }else if(operator == 2){//2 misionari
            if ((s.isLeft() && s.breh[0] < 2) || (!s.isLeft() && s.breh[0] > 1)){
                throw new Exception("operator 2 nelze pouzit");
            }
            if (s.isLeft()){
                breh[0] = s.breh[0]-2;
            }else{
                breh[0] = s.breh[0]+2;
            }
            breh[1] = s.breh[1];
        }else if (operator == 3){//1 kanibal
            if ((s.isLeft() && s.breh[1] == 0) || (!s.isLeft() && s.breh[1] == 3)){
                throw new Exception("operator 3 nelze pouzit");
            }
            if (s.isLeft()){
                breh[1] = s.breh[1]-1;
            }else{
                breh[1] = s.breh[1]+1;
            }
            breh[0] = s.breh[0];
            
        }else if (operator == 4){//2 kanibalove
            if ((s.isLeft() && s.breh[1] < 2) || (!s.isLeft() && s.breh[1] > 1)){
                throw new Exception("operator 4 nelze pouzit");
            }
            if (s.isLeft()){
                breh[1] = s.breh[1]-2;
            }else{
                breh[1] = s.breh[1]+2;
            }
            breh[0] = s.breh[0];
            
        }else if (operator == 5){//1x mis + 1x kan
            if ((s.isLeft() && (s.breh[0] == 0 || s.breh[1] == 0)) || (!s.isLeft() && (s.breh[0] == 3 || s.breh[1] == 3))){
                throw new Exception("operator 5 nelze pouzit");
            }
            if (s.isLeft()){
                breh[1] = s.breh[1]-1;
                breh[0] = s.breh[0]-1;
            }else{
                breh[1] = s.breh[1]+1;
                breh[0] = s.breh[0]+1;
            }
        }else{
            throw new Exception("neznamy operator");
        }
        breh[2] = (s.breh[2]+1) % 2;
        if (!isValid()){
            throw new Exception("nevalidni stav");
        }
        predek = s;
    }

    /** vraci true, pokud je lodka na levem brehu, jinak false **/
    public boolean isLeft(){
        if (breh[2] == 1){
            return true;
        }else{
            return false;
        }
    }
    public void printState(){
        System.out.println("("+breh[0]+","+breh[1]+","+breh[2]+")---("+(3-breh[0])+","+(3-breh[1])+","+(1-breh[2])+")");
    }
    /**kontroluje, zda je stav validni - kanibalove nesezerou misionare **/
    protected boolean isValid(){
        if ((this.breh[0] > 0 && this.breh[1] > this.breh[0]) || (this.breh[0]< 3 && this.breh[1] < this.breh[0])){
            return false;
        }else{
            return true;
        }
    }
    /**kontroluje, zda je stav koncovy - vsichni jsou prevezeni **/
    protected boolean isDone(){
        if (this.breh[0] == 0 & this.breh[1] == 0){
            return true;
        }else{
            return false;
        }
    }
    
}
